import java.lang.Integer;
import java.lang.Math;

public class Display{
        
        public enum DisplayMode {DEC, BIN, OCT, HEX, PCT }
        private DisplayMode displayMode = DisplayMode.DEC; 
        
        public DisplayMode getDisplayMode() {
            return displayMode;
        }
        
        public void setDisplayMode(DisplayMode mode) {
            displayMode = mode;
        }
        
        public String getDisplayString(double value) {                    
            switch(displayMode) {
                case DEC:
                    return Double.toString(value);
                case BIN:
                    return Integer.toBinaryString((int)value);
                case OCT:
                    return Integer.toOctalString((int)value);
                case HEX:
                    return Integer.toHexString((int)value);
                case PCT:
                    if(Math.abs(value) <= 1) {
                        return Integer.toString((int) (value * 100));
                    }else{
                        return Double.toString(value);
                    }
                default:
                    return null;
            }            
        }
    }

